/*
 * @(#)io_md.h	1.17 95/11/10  
 *
 * Copyright (c) 1994 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

/*
 * Solaris-dependent I/O
 */

#ifndef	_SOLARIS_IO_MD_H_
#define	_SOLARIS_IO_MD_H_

#include <sys/param.h>
#include <dirent.h>
#include <unistd.h>

#define sysOpen(_path,_oflag,_mode)     open(_path,_oflag,_mode)
#define sysRead(_fd,_buf,_n)		read(_fd,_buf,_n)
#define sysWrite(_fd,_buf,_n)		write(_fd,_buf,_n)
#define sysClose(_fd)			close(_fd)
#define sysAccess(_path,_mode)		access(_path,_mode)
#define sysStat(_path,_buf)		stat(_path,_buf)
#define sysMkdir(_path,_mode)		mkdir(_path,_mode)
#define sysUnlink(_path)		unlink(_path)
#define sysIsAbsolute(_path)		(*(_path) == '/')
#define sysCloseDir(_dir)		closedir(_dir)
#define sysOpenDir(_path)		opendir(_path)
#define sysReadDir(_dir)		readdir(_dir)

#endif	/* !_SOLARIS_IO_MD_H_ */
